unit T_BiancoOffice;

//22/10/97
//Office 97

interface

uses
 {$IFDEF WIN32}
  Windows,
 {$ELSE}
  WinProcs, WinTypes,
 {$ENDIF}
 SysUtils, Messages, Classes, Graphics, Controls,
 Forms, Dialogs, ExtCtrls,StdCtrls,DBCtrls,Comctrls;

Type
  TBPanel97=class(TPanel)
  Private
   IsIn:Boolean;
   procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  Protected
   procedure Paint; override;
   constructor Create(AOwner: TComponent); override;
  end;

  TBLabel97=class(TLabel)
  Private
   IsIn:Boolean;
   procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  Protected
   procedure Paint; override;
   constructor Create(AOwner: TComponent); override;
  end;

  TBEdit97=class(TCustomEdit)
  private
    B,F:TColor;
    S:TBORDERSTYLE;
    MouseInControl: Boolean;
    procedure RedrawBorder (const Clip: HRGN);
    procedure NewAdjustHeight;
    procedure CMEnabledChanged (var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure CMFontChanged (var Message: TMessage); message CM_FONTCHANGED;
    procedure CMMouseEnter (var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave (var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMSetFocus (var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus (var Message: TWMKillFocus); message WM_KILLFOCUS;
    procedure WMNCCalcSize (var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint (var Message: TMessage); message WM_NCPAINT;
  protected
    procedure Loaded; override;
  public
    constructor Create (AOwner: TComponent); override;
  published
    property CharCase;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    PROPERTY Color;
    property HideSelection;
    property MaxLength;
    property OEMConvert;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

  TBMemo97=class(TMemo)
  Private
   B,F:TColor;
   S:TBORDERSTYLE;
   procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  public
   constructor Create (AOwner: TComponent); override;
  end;

  TBGroupBox97=class(TGroupBox)
  Private
   IsIn:Boolean;
   procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  public
   procedure Paint; override;
   constructor Create (AOwner: TComponent); override;
  end;

  TBListBox97=class(TListBox)
  Private
   B,F:TColor;
   S:TBORDERSTYLE;
   procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  public
   constructor Create (AOwner: TComponent); override;
  end;

  TBCheckBox97=class(TCustomControl)
  private
    FState:TCheckBoxState;
    ISIN:BOOLEAN;
    FFocused:Boolean;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  protected
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState;X, Y: Integer);
      override;
    procedure KeyDown(var Key:Word;Shift:TShiftSTate); override;
    procedure KeyUp(var Key:Word;Shift:TShiftSTate); override;
    procedure SetState(Value:TCheckBoxState);
    procedure SetChecked(Value:Boolean);
    function  GetChecked:Boolean;
    function  GetCaption: TCaption;
    procedure SetCaption(const Value:TCaption);
    procedure DoEnter; override;
    procedure DoExit; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property Caption;
    property Checked:Boolean read GetChecked write SetChecked;
    property DragCursor;
    property DragMode;
    property Font;
    property Color;
    property ParentFont;
    property PopupMenu;
    Property Visible;
    property ShowHint;
    property State:TCheckBoxState read FState write SetState;
    property TabOrder;
    property TabStop;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

 TBRadioButton97 = class(TCustomControl)
  private
    FChecked:Boolean;
    ISIN:BOOLEAN;
    FFocused:Boolean;
    FCheckColor:TColor;
    FGroupIndex:Byte;
    Procedure CERCHIO(CENX,CENY,RAGG:INTEGER);
    procedure TurnSiblingsOff;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  protected
    constructor Create(AOwner: TComponent); override;
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState;X, Y: Integer);
      override;
    procedure KeyDown(var Key:Word;Shift:TShiftSTate); override;
    procedure KeyUp(var Key:Word;Shift:TShiftSTate); override;
    function  GetCaption: TCaption;
    procedure SetCaption(const Value:TCaption);
    procedure SetChecked(Value:Boolean);
    procedure SetCheckColor(Value:TColor);
    procedure DoEnter; override;
    procedure DoExit; override;
  public
  published
    property Caption;//:TCaption read GetCaption write SetCaption;
    property Checked:Boolean read FChecked write SetChecked;
    property DragCursor;
    property DragMode;
    property Font;
    property Visible;
    property GroupIndex:Byte read FGroupIndex write FGroupIndex;
    property ParentFont;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

  TBDBNav97=class(TDBNavigator)
  Private
   IsIn:Boolean;
   procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  public
   procedure RePaint; override;
   constructor Create (AOwner: TComponent); override;
  end;

  TBRichEdit97=class(TRichEdit)
  Private
   B,F:TColor;
   S:TBORDERSTYLE;
   procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  public
   constructor Create (AOwner: TComponent); override;
  end;


procedure Register;

implementation

procedure S_M;
 Begin
  Randomize;
  If Random(4000) = 2 Then
   ShowMessage('By:'+#13+'Bianchini Marco'+#13+'bianco@arcanet.it'+#13+'http://www.arcanet.it/bianco');
 End;

//TPanel
procedure TBPanel97.CMMouseEnter(var Message: TMessage);
begin
 IsIn:=True;
 Repaint;
end;

procedure TBPanel97.CMMouseLeave(var Message: TMessage);
begin
 IsIn:=False;
 Repaint;
end;

procedure TBPanel97.Paint;
Var
 Dx,Dy:Integer;
 C:TColor;
begin
 s_m;
 If IsIn and Enabled Then
  Inherited Paint
 Else
  With Canvas do
   Begin
    Brush.Color:=Self.Color;
    Pen.Color:=clGrayText;
    Rectangle(0,0,Width,Height);
    Rectangle(BorderWidth,BorderWidth,Width-BorderWidth,Height-BorderWidth);
    If Caption<>'' then
     Begin
      Font:=Self.Font;
      Dx:=TextWidth(Caption);
      Dy:=TextHeight(Caption);
      C:=Font.Color;
      Font.Color:=clGrayText;
      TextOut((Width-Dx) Div 2,(Height-Dy) Div 2,Caption);
      Font.Color:=C;
     End;
   End;
end;

Constructor TBPanel97.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  IsIn:=True;
 End;

//TLabel
procedure TBLabel97.CMMouseEnter(var Message: TMessage);
begin
 IsIn:=True;
 Repaint;
end;

procedure TBLabel97.CMMouseLeave(var Message: TMessage);
begin
 IsIn:=False;
 Repaint;
end;

procedure TBLabel97.Paint;
Var
 Dx:Integer;
 C:TColor;
begin
 s_m;
 If IsIn and Enabled Then
  Inherited Paint
 Else
  With Canvas do
   Begin
    If Not Transparent Then
     Begin
      Brush.Color:=Self.Color;
      Pen.Color:=Self.Color;
      Rectangle(0,0,Width,Height);
     End;
    If Caption<>'' then
     Begin
      Font:=Self.Font;
      Dx:=TextWidth(Caption);
      C:=Font.Color;
      Font.Color:=clGrayText;
      Case Self.Alignment of
       taCenter:TextOut((Width-Dx) Div 2,0,Caption);
       taLeftJustify:TextOut(0,0,Caption);
       taRightJustify:TextOut(Width-Dx,0,Caption);
      End;

      Font.Color:=C;
     End;
   End;
end;

Constructor TBLabel97.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  IsIn:=True;
 End;

//TEdit
constructor TBEdit97.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  AutoSize := False;
  Ctl3D := False;
  BorderStyle := bsNone;
  ControlStyle := ControlStyle - [csFramed]; {fixes a VCL bug with Win 3.x}
  Height := 19;
  B:=COLOR;
  F:=FONT.COLOR;
  S:=BORDERSTYLE;
end;

procedure TBEdit97.CMMouseEnter (var Message: TMessage);
begin
  inherited;
  COLOR:=B;
  FONT.COLOR:=F;
  BORDERSTYLE:=S;
  MouseInControl := True;
  RedrawBorder (0);
end;

procedure TBEdit97.CMMouseLeave (var Message: TMessage);
 begin
  inherited;
  IF NOT FOCUSED THEN
   BEGIN
    BORDERSTYLE:=bsNone;
    COLOR:=CLBTNFACE;
    FONT.COLOR:=CLGRAYTEXT;
   END;
  MouseInControl := False;
  RedrawBorder (0);
 end;

procedure TBEdit97.NewAdjustHeight;
var
  DC: HDC;
  SaveFont: HFONT;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  SaveFont := SelectObject(DC, Font.Handle);
  GetTextMetrics (DC, Metrics);
  SelectObject (DC, SaveFont);
  ReleaseDC (0, DC);

  Height := Metrics.tmHeight + 6;
end;

procedure TBEdit97.Loaded;
begin
  inherited Loaded;
  if not(csDesigning in ComponentState) then
    NewAdjustHeight;
end;

procedure TBEdit97.CMEnabledChanged (var Message: TMessage);
const
  EnableColors: array[Boolean] of TColor = (clBtnFace, clWindow);
begin
  inherited;
  Color := EnableColors[Enabled];
end;

procedure TBEdit97.CMFontChanged (var Message: TMessage);
begin
  inherited;
  if not((csDesigning in ComponentState) and (csLoading in ComponentState)) then
    NewAdjustHeight;
end;

procedure TBEdit97.WMSetFocus (var Message: TWMSetFocus);
begin
  inherited;
  if not(csDesigning in ComponentState) then
    RedrawBorder (0);
end;

procedure TBEdit97.WMKillFocus (var Message: TWMKillFocus);
begin
  inherited;
  if not(csDesigning in ComponentState) then
    RedrawBorder (0);
end;

procedure TBEdit97.WMNCCalcSize (var Message: TWMNCCalcSize);
begin
  inherited;
  InflateRect (Message.CalcSize_Params^.rgrc[0], -3, -3);
end;

procedure TBEdit97.WMNCPaint (var Message: TMessage);
begin
  inherited;
  RedrawBorder (Message.WParam);
end;

procedure TBEdit97.RedrawBorder (const Clip: HRGN);
var
  DC: HDC;
  R: TRect;
  NewClipRgn: HRGN;
  BtnFaceBrush, WindowBrush: HBRUSH;
begin
  s_m;
  DC := GetWindowDC(Handle);
  try
    if Clip <> 0 then begin
      GetWindowRect (Handle, R);
      { An invalid region is generally passed when the window is first created }
      if SelectClipRgn(DC, Clip) = ERROR then begin
        NewClipRgn := CreateRectRgnIndirect(R);
        SelectClipRgn (DC, NewClipRgn);
        DeleteObject (NewClipRgn);
      end;
      OffsetClipRgn (DC, -R.Left, -R.Top);
    end;

    { This works around WM_NCPAINT problem described at top of source code }
    {no!  R := Rect(0, 0, Width, Height);}
    GetWindowRect (Handle, R);  OffsetRect (R, -R.Left, -R.Top);
    BtnFaceBrush := CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
    WindowBrush := CreateSolidBrush(GetSysColor(COLOR_WINDOW));
    if ((csDesigning in ComponentState) and Enabled) or
       (not(csDesigning in ComponentState) and
        (Focused or (MouseInControl and not(Screen.ActiveControl is TBEdit97)))) then begin
      DrawEdge (DC, R, BDR_SUNKENOUTER, BF_RECT or BF_ADJUST);
      FrameRect (DC, R, BtnFaceBrush);
      InflateRect (R, -1, -1);
      FrameRect (DC, R, WindowBrush);
    end
    else begin
      FrameRect (DC, R, BtnFaceBrush);
      InflateRect (R, -1, -1);
      FrameRect (DC, R, BtnFaceBrush);
      InflateRect (R, -1, -1);
      FrameRect (DC, R, WindowBrush);
    end;
    DeleteObject (WindowBrush);
    DeleteObject (BtnFaceBrush);
  finally
    ReleaseDC (Handle, DC);
  end;
end;

//TMemo
procedure TBMemo97.CMMouseEnter(var Message: TMessage);
begin
 COLOR:=B;
 FONT.COLOR:=F;
 BORDERSTYLE:=S;
end;

procedure TBMemo97.CMMouseLeave(var Message: TMessage);
begin
 BORDERSTYLE:=bsNone;
 COLOR:=CLBTNFACE;
 FONT.COLOR:=CLGRAYTEXT;
end;

Constructor TBMemo97.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  B:=COLOR;
  F:=FONT.COLOR;
  S:=BORDERSTYLE;
 End;

//TGroupBox
procedure TBGroupBox97.CMMouseEnter(var Message: TMessage);
begin
 IsIn:=True;
 Repaint;
end;

procedure TBGroupBox97.CMMouseLeave(var Message: TMessage);
begin
 IsIn:=False;
 Repaint;
end;

procedure TBGroupBox97.Paint;
Var
 C:TColor;
begin
 If IsIn and Enabled Then
  Inherited Paint
 Else
  With Canvas do
   Begin
    Brush.Color:=Self.Color;
    Pen.Color:=Self.Color;
    Rectangle(0,0,Width,Height);
    Pen.Color:=clGrayText;
    Rectangle(0,SELF.FONT.SIZE DIV 2+3,Width,Height);
    If Caption<>'' then
     Begin
      Font:=Self.Font;
      C:=Font.Color;
      Font.Color:=clGrayText;
      TextOut(10,0,Caption);
      Font.Color:=C;
     END;
   End;
end;

Constructor TBGroupBox97.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  IsIn:=True;
 End;

//TListBox
procedure TBListBox97.CMMouseEnter(var Message: TMessage);
begin
 COLOR:=B;
 FONT.COLOR:=F;
 BORDERSTYLE:=S;
end;

procedure TBListBox97.CMMouseLeave(var Message: TMessage);
begin
 BORDERSTYLE:=bsNone;
 COLOR:=CLBTNFACE;
 FONT.COLOR:=CLGRAYTEXT;
end;

Constructor TBListBox97.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  s_m;
  B:=COLOR;
  F:=FONT.COLOR;
  S:=BORDERSTYLE;
 End;

//TCheckBox
procedure TBCheckBox97.CMMouseEnter(var Message: TMessage);
begin
 IsIn:=True;
 Paint;
end;

procedure TBCheckBox97.CMMouseLeave(var Message: TMessage);
begin
 IsIn:=False;
 Paint;
end;

constructor TBCheckBox97.Create(AOwner: TComponent);

begin
  inherited Create(AOwner);
  Width := 98;
  Height := 20;
  ParentColor:=False;
  Color:=clBtnFace;
end;

const BW=12;

procedure TBCheckBox97.Paint;
 var BL,BT,BR,BB:Integer;
     TX,TY,TW,TH:Integer;
     Rect:TRect;
     C:TColor;
 begin
  s_m;
  Canvas.Font:=Font;
  with Canvas do
   begin
    BT:=(Height div 2)-(BW div 2);
    BB:=BT+BW;
    BL:=1;
    BR:=BW+1;
    if isin then
     begin
      Pen.Color:=CLbtnshadow;
      Brush.color:=CLWindow;
     End
    Else
     Begin
      Pen.Color:=clBtnShadow;
      Brush.color:=Self.Color;
     End;
    Rectangle(BL+1,BT+1,BR,BB);
    if isin then
     Pen.Color:=clBtnShadow;
    MoveTo(BL,BB);
    LineTo(BL,BT);
    LineTo(BR,BT);
    if isin then
     Pen.Color:=clBtnHighLight;
    LineTo(BR,BB);
    LineTo(BL,BB);
    brush.style:=bsClear;
    TX:=BR+5;
    TY:=(Height div 2)+(Font.Height div 2)-1;
    TW:=TextWidth(Caption);
    TH:=TextHeight(Caption);
    If Not IsIn Then
     Begin
      C:=Font.Color;
      Font.color:=clgraytext;
      TextOut(TX,TY,Caption);
      Font.Color:=C;
     End
    Else
     TextOut(TX,TY,Caption);
    CASE STATE OF
     cbGrayed,cbChecked:bEGIN
    if (Not isin) {or (cbGrayed in fState)} then
     Pen.Color:=clgraytext
    Else
     Pen.Color:=clWindowText;
    Pen.Width:=1;
    Dec(BT);Dec(BB);
    MoveTo(BL+2,BT+BW div 2+1);
    LineTo(BL+2,BB-1);
    MoveTo(BL+3,BT+BW div 2);
    LineTo(BL+3,BB-2);
    MoveTo(BL+2,BB-1);
    LineTo(BR-2,BT+3);
    MoveTo(BL+3,BB-1);
    LineTo(BR-1,BT+3);       END;
    END;
    if FFocused then
     BEGIN
      Brush.Color:=clBtnFace;
      Rect:=Bounds(TX-1,TY,TW+3,TH+1);
      FrameRect(Rect);
      DrawFocusRect(Rect);
     end;
   eND;
end;

function TBCheckBox97.GetCaption:TCaption;

var Buf:array[0..256] of Char;

begin
     GetTextBuf(Buf,256);
     Result:=StrPas(Buf);
end;

procedure TBCheckBox97.SetCaption(const Value:TCaption);

var Buffer: array[0..255] of Char;

begin
     if GetCaption <> Value then
       SetTextBuf(StrPCopy(Buffer,Value));
     Invalidate;
end;

procedure TBCheckBox97.SetState(Value:TCheckBoxState);

begin
     if FState<>Value then
       begin
         FState:=Value;
         Paint;
         Click;
       end;
end;

function TBCheckBox97.GetChecked: Boolean;

begin
     Result:=State=cbChecked;
end;

procedure TBCheckBox97.SetChecked(Value:Boolean);

begin
 if Value then State := cbChecked
  else State := cbUnchecked;
end;

procedure TBCheckBox97.DoEnter;

begin
     inherited DoEnter;
     FFocused:=True;
     Paint;
end;

procedure TBCheckBox97.DoExit;

begin
     inherited DoExit;
     FFocused:=False;
     Paint;
end;

procedure TBCheckBox97.MouseDown(Button: TMouseButton; Shift: TShiftState;
                                  X, Y: Integer);

begin
     SetFocus;
     FFocused:=True;
     inherited MouseDown(Button, Shift, X, Y);
     MouseCapture:=True;
end;

procedure TBCheckBox97.MouseUp(Button: TMouseButton; Shift: TShiftState;
                                  X, Y: Integer);

begin
     MouseCapture:=False;
     if (X>=0) and (X<=Width) and (Y>=0) and (Y<=Height) then
       Checked:=not Checked;
     inherited MouseUp(Button, Shift, X, Y);
end;

procedure TBCheckBox97.MouseMove(Shift: TShiftState;X, Y: Integer);

begin
     inherited MouseMove(Shift,X,Y);
end;

procedure TBCheckBox97.KeyDown(var Key:Word;Shift:TShiftSTate);

begin
     inherited KeyDown(Key,Shift);
end;

procedure TBCheckBox97.KeyUp(var Key:Word;Shift:TShiftSTate);
begin
 if Key=vk_Space then
  Checked:=not Checked;
end;

//RADIOBUTTON
procedure TBRadioButton97.CMMouseEnter(var Message: TMessage);
begin
 IsIn:=True;
 //REFRESH;
 Paint;
end;

procedure TBRadioButton97.CMMouseLeave(var Message: TMessage);
begin
 IsIn:=False;
 //REFRESH;
 Paint;
end;

constructor TBRadioButton97.Create(AOwner: TComponent);

begin
  inherited Create(AOwner);
  Width := 98;
  Height := 20;
  ParentColor:=False;
  Color:=clBtnFace;
end;

Procedure TBRadioButton97.CERCHIO(CENX,CENY,RAGG:INTEGER);
 Var
  A:Integer;
  CosX,SinY:Double;
 BEGIN
  With Canvas do
   Begin
    MoveTo(CenX+Ragg,CenY);
    A:=0;
    Repeat
     Inc(A);
     CosX:=Ragg*Cos(A*(PI/180));
     SinY:=Ragg*Sin(A*(PI/180));
     If (A In [45..225]) Then
      Pen.Color:=ClBTNSHADOW
     Else
      Pen.Color:=ClBTNHIGHLIGHT;
     LineTo(CenX+Trunc(CosX),CenY-Trunc(SinY));
    Until A>=360;
   End;
 END;

procedure TBRadioButton97.Paint;
var BL,BT,BR,BB,BM:Integer;
    TX,TY,TW,TH:Integer;
    Rect:TRect;
    C:TCOLOR;
begin
 s_m;
 Canvas.Font:=Font;
 with Canvas do
  begin
   BRUSH.COLOR:=SELF.COLOR;
   BRUSH.STYLE:=BSSOLID;
   PEN.COLOR:=SELF.COLOR;
   RECTANGLE(0,0,WIDTH,HEIGHT);
   BT:=(Height div 2)-(BW div 2);
   BB:=BT+BW;
   BL:=1;
   BR:=BW+1;
   BM:=BW div 2;
   if isin then
    begin
     Pen.Color:=CLbtnshadow;
     Brush.color:=CLWindow;
    End
   Else
    Begin
     Pen.Color:=clgraytext;
     Brush.color:=Self.Color;
    End;
   ELLIPSE(BL+1,BT+1,BR-1,BB-1);
   IF ISIN THEN
    CERCHIO(BL+BM,BT+BM,BM);

   if Checked then
    begin
     if isin then
      begin
       Pen.Color:=CLwINDOWTEXT;
       Brush.color:=CLWindoWTEXT;
      End
     Else
      Begin
       Pen.Color:=clgraytext;
       Brush.color:=CLGRAYTEXT;
      End;
    ELLIPSE(BL+BM-2,BT+BM-2,BR-BM+2,BB-BM+2);
    end;
    TX:=BR+5;
    TY:=(Height div 2)+(Font.Height div 2)-1;
    TW:=TextWidth(Caption);
    TH:=TextHeight(Caption);
    BRUSH.STYLE:=BSCLEAR;
    If Not IsIn Then
     Begin
      C:=Font.Color;
      Font.color:=clgraytext;
      TextOut(TX,TY,Caption);
      Font.Color:=C;
     End
    Else
     TextOut(TX,TY,Caption);
    if FFocused then
     BEGIN
      Brush.Color:=clBtnFace;
      Rect:=Bounds(TX-1,TY,TW+3,TH+1);
      FrameRect(Rect);
      DrawFocusRect(Rect);
     END;
  end;
end;

function TBRadioButton97.GetCaption:TCaption;

var Buf:array[0..256] of Char;

begin
     GetTextBuf(Buf,256);
     Result:=StrPas(Buf);
end;

procedure TBRadioButton97.SetCaption(const Value:TCaption);

var Buffer: array[0..255] of Char;

begin
     if GetCaption <> Value then
       SetTextBuf(StrPCopy(Buffer,Value));
     Invalidate;
end;

procedure TBRadioButton97.TurnSiblingsOff;

var i:Integer;
    Sibling: TBRadioButton97;

begin
     if Parent <> nil then
       for i:=0 to Parent.ControlCount-1 do
         if Parent.Controls[i] is TBRadioButton97 then
           begin
             Sibling:=TBRadioButton97(Parent.Controls[i]);
             if (Sibling<>Self) and
                (Sibling.GroupIndex=GroupIndex) then
                  Sibling.SetChecked(False);
           end;
end;

procedure TBRadioButton97.SetChecked(Value: Boolean);

begin
     if FChecked <> Value then
       begin
         TabStop:=Value;
         FChecked:=Value;
         if Value then
           begin
             TurnSiblingsOff;
             Click;
           end;
         Paint;
       end;
end;

procedure TBRadioButton97.SetCheckColor(Value:TColor);

begin
     FCheckColor:=Value;
     Paint;
end;

procedure TBRadioButton97.DoEnter;

begin
     inherited DoEnter;
     FFocused:=True;
     Checked:=True;
     Paint;
end;

procedure TBRadioButton97.DoExit;

begin
     inherited DoExit;
     FFocused:=False;
     Paint;
end;

procedure TBRadioButton97.MouseDown(Button: TMouseButton; Shift: TShiftState;
                                  X, Y: Integer);

begin
     SetFocus;
     FFocused:=True;
     inherited MouseDown(Button, Shift, X, Y);
     MouseCapture:=True;
end;

procedure TBRadioButton97.MouseUp(Button: TMouseButton; Shift: TShiftState;
                                  X, Y: Integer);

begin
     MouseCapture:=False;
     if (X>=0) and (X<=Width) and (Y>=0) and (Y<=Height)
       and not Checked then Checked:=True;
     inherited MouseUp(Button, Shift, X, Y);
end;

procedure TBRadioButton97.MouseMove(Shift: TShiftState;X, Y: Integer);
 begin
  inherited MouseMove(Shift,X,Y);
 end;

procedure TBRadioButton97.KeyDown(var Key:Word;Shift:TShiftSTate);

begin
     inherited KeyDown(Key,Shift);
end;

procedure TBRadioButton97.KeyUp(var Key:Word;Shift:TShiftSTate);

begin
     if Key=vk_Space then
       begin
         if not Checked then Checked:=True;
       end;
end;

//TDBNav
procedure TBDBNav97.CMMouseEnter(var Message: TMessage);
begin
 if not isin then begin
 IsIn:=True;
 Repaint;     end;
end;

procedure TBDBNav97.CMMouseLeave(var Message: TMessage);
begin
 if isin then begin
 IsIn:=False;
 Repaint;     end;
end;

procedure TBDBNav97.RePaint;
Var
 Dx,X,N,A:Integer;
begin
 s_m;
 Inherited RePaint;
 If Not (IsIn and Enabled) Then
  With Canvas do
   Begin
    Brush.Color:=CLbTNfACE;
    Pen.Color:=CLBTNFACE;
    Brush.Style:=bsClear;
    Rectangle(0,0,Width,Height);
    Rectangle(1,1,Width-1,Height-1);
  //Trova il numero di quadrati
    N:=0;
    If nbFirst in VisibleButtons then inc(N);
    If nbPrior in VisibleButtons then inc(N);
    If nbNext in VisibleButtons then inc(N);
    If nbLast in VisibleButtons then inc(N);
    If nbInsert in VisibleButtons then inc(N);
    If nbDelete in VisibleButtons then inc(N);
    If nbEdit in VisibleButtons then inc(N);
    If nbPost in VisibleButtons then inc(N);
    If nbCancel in VisibleButtons then inc(N);
    If nbRefresh in VisibleButtons then inc(N);
    If N>0 then
     Begin
      Brush.Style:=bsSolid;
      Brush.Color:=CLbTNfACE;
      Pen.Color:=CLBTNFACE;
      X:=0;
      Dx:=Width Div N;
      For A:=1 to N-1 do
       BEGIN
        INC(X,DX);
        Dx:=(WIDTH-X) Div (N-A);
        Rectangle(X-3,0,X+3,Height);
       END
     End;
   End;
 end;

Constructor TBDBNav97.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  IsIn:=True;
 End;


//TRichEdit
procedure TBRichEdit97.CMMouseEnter(var Message: TMessage);
begin
 COLOR:=B;
 FONT.COLOR:=F;
 BORDERSTYLE:=S;
end;

procedure TBRichEdit97.CMMouseLeave(var Message: TMessage);
begin
 BORDERSTYLE:=bsNone;
 COLOR:=CLBTNFACE;
 FONT.COLOR:=CLGRAYTEXT;
end;

Constructor TBRichEdit97.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
  s_m;
  B:=COLOR;
  F:=FONT.COLOR;
  S:=BORDERSTYLE;
 End;



//****************************************************************


procedure Register;
 begin
  RegisterComponents('BiancoOffice97',[TBPanel97,
                                       TBLabel97,
                                       TBEdit97,
                                       TBMemo97,
                                       TBGroupBox97,
                                       TBListBox97,
                                       TBCheckBox97,
                                       TBRadioButton97,
                                       TBDBNav97,
                                       TBRichEdit97]);
 end;

end.

{
procedure TBDBNav97.RePaint;
Var
// P:TPOINT;
 Dx,N,A,Y:Integer;
 C:TColor;
 B:TBitmap;
 R:TRect;
begin
// GetCursorPos(P);
// P:=ClientToscreen(P);
 If IsIn and Enabled Then
  Inherited RePaint
 Else
  With Canvas do
   Begin
    Brush.Color:=Self.Color;
    Pen.Color:=SELF.COLOR;
    Rectangle(0,0,Width,Height);

    //Trova il numero di quadrati
    N:=0;
    If nbFirst in VisibleButtons then inc(N);
    If nbPrior in VisibleButtons then inc(N);
    If nbNext in VisibleButtons then inc(N);
    If nbLast in VisibleButtons then inc(N);
    If nbInsert in VisibleButtons then inc(N);
    If nbDelete in VisibleButtons then inc(N);
    If nbEdit in VisibleButtons then inc(N);
    If nbPost in VisibleButtons then inc(N);
    If nbCancel in VisibleButtons then inc(N);
    If nbRefresh in VisibleButtons then inc(N);
    If N>0 then
     Begin
      Dx:=Width Div N;
      For A:=1 to N do
       Rectangle((a-1)*Dx,0,a*Dx,Height);
      B:=TBitmap.create;
      A:=0;
      Y:=(Height-13) Div 2;
      Try
       If nbFirst in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_FIRST');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbPrior in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_PRIOR');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbNext in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_NEXT');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbLast in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_LAST');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbInsert in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_INSERT');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbDelete in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_DELETE');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbEdit in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_EDIT');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbPost in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_POST');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbCancel in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_CANCEL');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;
       If nbRefresh in VisibleButtons then
        Begin
         B.Handle:=LoadBitmap(hInstance,'MODBN_REFRESH');
         canvas.draw(A*Dx+(Dx-14) Div 2,Y,B);
         Inc(A);
        End;                
      Finally
       B.Free;
      End;
     End;
   End;
end;
}
